#ifndef __MLSDIALOG_H__
#define __MLSDIALOG_H__

#include <stdarg.h>
#include "define.h"

namespace MLSUTIL
{
	///	@brief	 메시지 박스
	void	MsgBox(const string& sTitle, const string& sMsg);

	///	@brief	 예, 아니오 박스
	bool	YNBox(const string& sTitle, const string& sMsg, bool bYes = false);

	///	@brief	 메시지 박스 시작. 대기화면에 사용.
	void*	MsgWaitBox(const string& sTitle, const string& sMsg);
	///	@brief	 메시지 박스 끝. 대기화면에 사용.
	void	MsgWaitEnd(void* );

	///	@brief	 입력창
	/// @param	sTitle		제목
	/// @param	sInputStr	입력된 Str
	/// @param	bPasswd		패스워드 형식 (영문만 입력 가능하게)
	/// @return	성공 SUCCESS
	int		InputBox(const string& sTitle, string& sInputStr, bool bPasswd = false);

	///	@brief	 선택 박스
	/// @param	sTitle		제목
	/// @param	vMsgStr		선택할 데이터들
	/// @param	n			선택번호
	/// @return	선택된 번호
	int 	SelectBox(	const string& sTitle,
						vector<string>& vMsgStr,
						int n = 0);

	///	@brief	 키 읽기.
	int 	GetChar(bool bNoDelay = false);

	///	@brief	 상태출력 박스
	class ProgressBox
	{
		protected:
			void*		_pVoidTmp;		///< void Tmp 형태. 형변환 해서 사용 바람.
			bool		_bDouble;		///< Progress가 위아래 두개면 true
			string		_sTitle, _sMsg;
			string 		_sLeftStr, _sRightStr;
			string 		_sLeftStr2, _sRightStr2;

			int 		_nCnt;  		///< 카운터 기준 (% 단위)
			int 		_nCnt2;  		///< 카운터 기준 (% 단위)
		
		public:
			ProgressBox(const string& sTitle, const string& sMsg, bool bDouble = false);
			~ProgressBox();

			void 	setLeftStr(const string& p)  { _sLeftStr=p; }
			void 	setRightStr(const string& p) { _sRightStr=p; }
			void 	setLeftStr2(const string& p)  { _sLeftStr2=p; }
			void 	setRightStr2(const string& p) { _sRightStr2=p; }

			virtual	bool isExit();

			virtual void show();
			virtual void redraw();
		
			virtual void setCount(int nCnt, int nCnt2 = -1)
			{
				_nCnt = nCnt;
				if (nCnt2 != -1) _nCnt2 = nCnt2;
			}
	};
};

#endif
