/******************************************************************************
 *   Copyright (C) 2005 by la9527                                             *
 *                                                                            *
 *  This program is free software; you can redistribute it and/or modify      * 
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  This program is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with this program; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.*
 ******************************************************************************/

#include "keycfgload.h"

using namespace MLSUTIL;
using namespace MLS;

bool	KeyCfgLoad::Parsing(const string& sSection, const string& sVar, const string& sVal)
{
	g_Log.Write("Parsing sSection [%s] var [%s] val [%s]", sSection.c_str(), sVar.c_str(), sVal.c_str());

	if (sSection == "KeyCodeSetting")
	{
		KeyInfo		tKeyInfo;
	
		StringToken		tToken(sVal, " ,");
		string			sTmp, sTmp2;

		vector<int>		vKey;
		while(tToken.Next())
		{
			sTmp = tToken.Get();
			StringToken		tToken2(sTmp, " :");
	
			vKey.clear();
			while(tToken2.Next())
			{
				sTmp2 = tToken2.Get();
				if (sTmp2.size() == 3 && sTmp2[0] == '\'' && sTmp2[2] == '\'')
				{
					vKey.push_back((int)sTmp2[2]);
				}
				else
				{
					vKey.push_back(strtoint(sTmp2));
				}
			}

			tKeyInfo.vKeyInfo = vKey;
			tKeyInfo.sKeyName = sVar;
			
			_vKeyList.push_back(tKeyInfo);
		}
	}

	if (sSection == "Command") // 실행 명령
	{
		StringToken		tToken(sVal, " ,");
		string			sTmp;

		while(tToken.Next())
		{
			sTmp = tToken.Get();
			_mapKeyCmd[sTmp] = sVar;
			g_Log.Write("[%s %s]", sTmp.c_str(), sVar.c_str());
		}
	}

	if (sSection == "KeyRun") // 키 눌렀을 때 쉘 실행
	{
		_mapRunCmd[sVar] = getbetween(sVal, '[', ']');
	}

	if (sSection == "Help")
	{
		_mapKeyHelp[sVar] = getbetween(sVal, '[', ']');
	}
}

KeyCfgLoad &KeyCfgLoad::GetInstance()
{
	static KeyCfgLoad instance;
	return instance;
}

