/******************************************************************************
 *   Copyright (C) 2005 by la9527                                             *
 *                                                                            *
 *  This program is free software; you can redistribute it and/or modify      * 
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  This program is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with this program; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.*
 ******************************************************************************/

#ifndef __MLS_MENU_H__
#define __MLS_MENU_H__

#include "dialog_menu.h"
#include "mainframe.h"

namespace MLS {

class MlsMenu:public Menu
{
protected:
	void MenuColorSetting()
	{
		_tColorMenu = g_tColorCfg.GetColorEntry("Func");
		_tColorMenuA = g_tColorCfg.GetColorEntry("FuncA");
	}
	
	void MenuAddCatecory()
	{
		MenuCategory mls("Mls");
			mls.AddItem(gettext("About"), "Cmd_About", false);
			mls.AddItem(gettext("Help"), "Cmd_Help", false);
			mls.AddItem("", "");
			mls.AddItem(gettext("Quit Mls"), "Cmd_Quit");
		AddItem(mls);
	
		MenuCategory run(gettext("Run"));
			run.AddItem(gettext("Run"), "Cmd_Enter");
			run.AddItem(gettext("Run(select)"), "Cmd_Execute", false);
			run.AddItem("", "");
			run.AddItem(gettext("Shell command"), "Cmd_Shell");
			run.AddItem("", "");
			run.AddItem(gettext("View console"), "Cmd_ESC");
		AddItem(run);
	
		MenuCategory files(gettext("File"));
			files.AddItem(gettext("New"), "Cmd_Newfile", false);
			files.AddItem(gettext("Touch File"), "Cmd_Touchfile", false);
			files.AddItem("", "");
			files.AddItem(gettext("CutClip"), "Cmd_CutClip");
			files.AddItem(gettext("CopyClip"), "Cmd_CopyClip");
			files.AddItem(gettext("PasteClip"), "Cmd_PasteClip");
			files.AddItem("", "");
			files.AddItem(gettext("Copy"), "Cmd_Copy", false);
			files.AddItem(gettext("Move"), "Cmd_Move");
			files.AddItem(gettext("Rename"), "Cmd_Rename");
			files.AddItem(gettext("Delete"), "Cmd_Remove");
			files.AddItem(gettext("Chmod"), "Cmd_Chmod", false);
			files.AddItem("", "");
			files.AddItem(gettext("View"), "Cmd_View");
			files.AddItem(gettext("Edit"), "Cmd_Edit");
			files.AddItem(gettext("Size info"), "Cmd_sizeinfo", false);
			files.AddItem(gettext("FileListSave"), "Cmd_Filelist", false);
			//files.AddItem(gettext("FileFind"), "", false);
			files.AddItem("", "");
			files.AddItem(gettext("Select all"), "Cmd_SelectAll");
			files.AddItem(gettext("Invert select"), "Cmd_SelectInvert");
			//files.AddItem(gettext("Select group"), "", false);
		AddItem(files);
	
		MenuCategory dire(gettext("Directory"));
			dire.AddItem("Mcd", "Cmd_MCD");
			dire.AddItem("Qcd", "Cmd_Qcd", false);
			dire.AddItem("", "");
			dire.AddItem(gettext("Mkdir"), "Cmd_Mkdir");
			dire.AddItem(gettext("To parent"), "Cmd_GoParent");
			dire.AddItem(gettext("To root"), "Cmd_GoRoot");
			dire.AddItem(gettext("To home"), "Cmd_GoHome");
			dire.AddItem("", "");
			dire.AddItem(gettext("Back"), "Cmd_Back", false);
			dire.AddItem(gettext("Forward"), "Cmd_Forward", false);
			//dire.AddItem("", "");
			//dire.AddItem(gettext("Properties"), "<properties>", false);
		AddItem(dire);
	
		MenuCategory util(gettext("Util"));
			util.AddItem(gettext("Ftp Connect"), "Cmd_FtpConn");
			util.AddItem(gettext("Ftp Close"), "Cmd_FtpClose");
			util.AddItem("","");
			util.AddItem(gettext("Extract"), "Cmd_Extract");
			util.AddItem("", "");
			util.AddItem(gettext("Compress (tar.gz)"), "Cmd_Targzcomp", false);
			util.AddItem(gettext("Compress (tar.bz2)"), "Cmd_Tarbz2comp", false);
			util.AddItem(gettext("Compress (zip)"), "Cmd_Zipcomp", false);
		AddItem(util);
	
		MenuCategory view(gettext("View"));
			view.AddItem(gettext("Refresh"), "Cmd_Refresh");
			view.AddItem("", "");
			view.AddItem(gettext("Column AUTO"), "Cmd_ColumnAuto");
			view.AddItem("", "");
			view.AddItem(gettext("Column 1"), "Cmd_Column1");
			view.AddItem(gettext("Column 2"), "Cmd_Column2");
			view.AddItem(gettext("Column 3"), "Cmd_Column3");
			view.AddItem(gettext("Column 4"), "Cmd_Column4");
			view.AddItem("", "");
			view.AddItem(gettext("Show/Hide hidden"), "Cmd_HiddenFileView");
			view.AddItem(gettext("Sort Change"), "Cmd_SortChange");
			view.AddItem("", "");
			view.AddItem(gettext("Split"),  "Cmd_Split");
			view.AddItem(gettext("Next window"), "Cmd_NextWindow");
			view.AddItem("", "");
			view.AddItem(gettext("SplitSync On/Off"), "Cmd_SplitViewSync");
			
		AddItem(view);
	
		MenuCategory op(gettext("Option"));
			op.AddItem(gettext("Linecode Change"), "Cmd_BoxCodeChange");
			op.AddItem(gettext("Korean Mode"), "Cmd_LangChange");
			op.AddItem("", "");
			op.AddItem(gettext("Edit Config"), "Cmd_Editconfig", false);
			op.AddItem(gettext("Edit Keybind"), "Cmd_Editkeybind", false);
			op.AddItem(gettext("Edit Colorset"), "Cmd_Editcolorset", false);
		AddItem(op);
	}

	// Reflash 할때 기타 화면을 Reflesh 꼭 넣어야 제대로 화면 나옴.
	void MenuRefresh()
	{
		g_tMainFrame.Refresh(true);
	}

};

};

#endif

